//+--------------------------------------------------------------------+
//|                                            #_i_SpecktrAnalis.mq4   |
//|                                          Copyright  2006, klot.   |
//|                                                     klot@mail.ru   |
//|          |
//+-------------------------------------------------------------------+|
#property copyright "Copyright  2006, klot."
#property link      "klot@mail.ru"

#define pi 3.14159265358979323846

#import "#_lib_FFT.ex4"
void fastfouriertransform(double& a[], int nn, bool inversefft);
void realfastfouriertransform(double& a[], int tnn, bool inversefft);
void fastcorellation(double& signal[], int signallen,  double& pattern[],  int patternlen);
void fastconvolution(double& signal[], int signallen, double& response[], int negativelen, int positivelen);
void fastsinetransform(double& a[], int tnn, bool inversefst);
void fastcosinetransform(double& a[], int tnn, bool inversefct);
void tworealffts(double a1[], double a2[],  double& a[],  double& b[], int tn);
void InSigNormalize(double& aa[]);
#import

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 DeepSkyBlue
#property indicator_color3 Gold


//---- buffers
double SpecktrBuffer[];
double PlusBuffer[];
double MinusBuffer[];

extern double n=9;   //  ( 2^n 
extern int SS=25;    // :  SS   
extern int delta=4;  //    > delta,  

int M,tnn1;
double aa[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,SpecktrBuffer);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,159);
   SetIndexBuffer(1, PlusBuffer);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,159);
   SetIndexBuffer(2, MinusBuffer);
   tnn1=MathPow(2,n);
   M=ArrayResize(aa,tnn1+1);
   if (SS>M) SS=M;
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int    counted_bars=IndicatorCounted();
   double sig;
   
   for(int i=M-1; i>=0; i--)
   {
      aa[i]=iClose(NULL,0,i);
   }        
   fastcosinetransform(aa, tnn1, false);   
   int N=ArraySize(aa);
      
   int Va=ArrayMaximum(aa,N-1,1);
   int Vb=ArrayMinimum(aa,N-1,1);
   
   for(i=1; i<=N-1; i++)
   {
      if (i>=SS) aa[i]=0;
   }   
   double m;
   
   fastcosinetransform(aa, tnn1, true);
   SetIndexDrawBegin(0,Bars-N);
   SetIndexDrawBegin(1,Bars-N);
   SetIndexDrawBegin(2,Bars-N);
   
   for( i=0; i<=N-1; i++)
   {
      double dd;
      SpecktrBuffer[i]=aa[i];
      dd=(aa[i]-aa[i+1])*240/Period();
      PlusBuffer[i]=0;
      MinusBuffer[i]=0;
      if(dd > delta*Point) PlusBuffer[i]=(aa[i]+aa[i+1])/2;
      if(dd < -delta*Point) MinusBuffer[i]=(aa[i]+aa[i+1])/2;      
   }
   
   return(0);
}
  

